// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-analytics-dtos.proto

package com.accelfin.server.demo.analytics.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto}
 */
public  final class FxAlertsReportResponseDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto)
    FxAlertsReportResponseDtoOrBuilder {
  // Use FxAlertsReportResponseDto.newBuilder() to construct.
  private FxAlertsReportResponseDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private FxAlertsReportResponseDto() {
    reportId_ = "";
    reportType_ = 0;
    rangeViewPrices_ = java.util.Collections.emptyList();
    mainViewPrices_ = java.util.Collections.emptyList();
    mainViewTrades_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private FxAlertsReportResponseDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            reportId_ = s;
            break;
          }
          case 16: {
            int rawValue = input.readEnum();

            reportType_ = rawValue;
            break;
          }
          case 26: {
            if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
              rangeViewPrices_ = new java.util.ArrayList<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto>();
              mutable_bitField0_ |= 0x00000004;
            }
            rangeViewPrices_.add(input.readMessage(com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.parser(), extensionRegistry));
            break;
          }
          case 34: {
            if (!((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
              mainViewPrices_ = new java.util.ArrayList<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto>();
              mutable_bitField0_ |= 0x00000008;
            }
            mainViewPrices_.add(input.readMessage(com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.parser(), extensionRegistry));
            break;
          }
          case 42: {
            if (!((mutable_bitField0_ & 0x00000010) == 0x00000010)) {
              mainViewTrades_ = new java.util.ArrayList<com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto>();
              mutable_bitField0_ |= 0x00000010;
            }
            mainViewTrades_.add(input.readMessage(com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.parser(), extensionRegistry));
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
        rangeViewPrices_ = java.util.Collections.unmodifiableList(rangeViewPrices_);
      }
      if (((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
        mainViewPrices_ = java.util.Collections.unmodifiableList(mainViewPrices_);
      }
      if (((mutable_bitField0_ & 0x00000010) == 0x00000010)) {
        mainViewTrades_ = java.util.Collections.unmodifiableList(mainViewTrades_);
      }
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportResponseDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportResponseDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto.class, com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto.Builder.class);
  }

  private int bitField0_;
  public static final int REPORT_ID_FIELD_NUMBER = 1;
  private volatile java.lang.Object reportId_;
  /**
   * <code>optional string report_id = 1;</code>
   */
  public java.lang.String getReportId() {
    java.lang.Object ref = reportId_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      reportId_ = s;
      return s;
    }
  }
  /**
   * <code>optional string report_id = 1;</code>
   */
  public com.google.protobuf.ByteString
      getReportIdBytes() {
    java.lang.Object ref = reportId_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      reportId_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int REPORT_TYPE_FIELD_NUMBER = 2;
  private int reportType_;
  /**
   * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
   */
  public int getReportTypeValue() {
    return reportType_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.ReportTypeDto getReportType() {
    com.accelfin.server.demo.analytics.dtos.ReportTypeDto result = com.accelfin.server.demo.analytics.dtos.ReportTypeDto.forNumber(reportType_);
    return result == null ? com.accelfin.server.demo.analytics.dtos.ReportTypeDto.UNRECOGNIZED : result;
  }

  public static final int RANGE_VIEW_PRICES_FIELD_NUMBER = 3;
  private java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> rangeViewPrices_;
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
   */
  public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> getRangeViewPricesList() {
    return rangeViewPrices_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
   */
  public java.util.List<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> 
      getRangeViewPricesOrBuilderList() {
    return rangeViewPrices_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
   */
  public int getRangeViewPricesCount() {
    return rangeViewPrices_.size();
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto getRangeViewPrices(int index) {
    return rangeViewPrices_.get(index);
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder getRangeViewPricesOrBuilder(
      int index) {
    return rangeViewPrices_.get(index);
  }

  public static final int MAIN_VIEW_PRICES_FIELD_NUMBER = 4;
  private java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> mainViewPrices_;
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
   */
  public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> getMainViewPricesList() {
    return mainViewPrices_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
   */
  public java.util.List<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> 
      getMainViewPricesOrBuilderList() {
    return mainViewPrices_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
   */
  public int getMainViewPricesCount() {
    return mainViewPrices_.size();
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto getMainViewPrices(int index) {
    return mainViewPrices_.get(index);
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder getMainViewPricesOrBuilder(
      int index) {
    return mainViewPrices_.get(index);
  }

  public static final int MAIN_VIEW_TRADES_FIELD_NUMBER = 5;
  private java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto> mainViewTrades_;
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
   */
  public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto> getMainViewTradesList() {
    return mainViewTrades_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
   */
  public java.util.List<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDtoOrBuilder> 
      getMainViewTradesOrBuilderList() {
    return mainViewTrades_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
   */
  public int getMainViewTradesCount() {
    return mainViewTrades_.size();
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto getMainViewTrades(int index) {
    return mainViewTrades_.get(index);
  }
  /**
   * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDtoOrBuilder getMainViewTradesOrBuilder(
      int index) {
    return mainViewTrades_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getReportIdBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 1, reportId_);
    }
    if (reportType_ != com.accelfin.server.demo.analytics.dtos.ReportTypeDto.FX_ALERTS.getNumber()) {
      output.writeEnum(2, reportType_);
    }
    for (int i = 0; i < rangeViewPrices_.size(); i++) {
      output.writeMessage(3, rangeViewPrices_.get(i));
    }
    for (int i = 0; i < mainViewPrices_.size(); i++) {
      output.writeMessage(4, mainViewPrices_.get(i));
    }
    for (int i = 0; i < mainViewTrades_.size(); i++) {
      output.writeMessage(5, mainViewTrades_.get(i));
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getReportIdBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(1, reportId_);
    }
    if (reportType_ != com.accelfin.server.demo.analytics.dtos.ReportTypeDto.FX_ALERTS.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(2, reportType_);
    }
    for (int i = 0; i < rangeViewPrices_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, rangeViewPrices_.get(i));
    }
    for (int i = 0; i < mainViewPrices_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, mainViewPrices_.get(i));
    }
    for (int i = 0; i < mainViewTrades_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, mainViewTrades_.get(i));
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto)
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportResponseDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportResponseDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto.class, com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        getRangeViewPricesFieldBuilder();
        getMainViewPricesFieldBuilder();
        getMainViewTradesFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      reportId_ = "";

      reportType_ = 0;

      if (rangeViewPricesBuilder_ == null) {
        rangeViewPrices_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
      } else {
        rangeViewPricesBuilder_.clear();
      }
      if (mainViewPricesBuilder_ == null) {
        mainViewPrices_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000008);
      } else {
        mainViewPricesBuilder_.clear();
      }
      if (mainViewTradesBuilder_ == null) {
        mainViewTrades_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000010);
      } else {
        mainViewTradesBuilder_.clear();
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportResponseDto_descriptor;
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto build() {
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto buildPartial() {
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto result = new com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      result.reportId_ = reportId_;
      result.reportType_ = reportType_;
      if (rangeViewPricesBuilder_ == null) {
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          rangeViewPrices_ = java.util.Collections.unmodifiableList(rangeViewPrices_);
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.rangeViewPrices_ = rangeViewPrices_;
      } else {
        result.rangeViewPrices_ = rangeViewPricesBuilder_.build();
      }
      if (mainViewPricesBuilder_ == null) {
        if (((bitField0_ & 0x00000008) == 0x00000008)) {
          mainViewPrices_ = java.util.Collections.unmodifiableList(mainViewPrices_);
          bitField0_ = (bitField0_ & ~0x00000008);
        }
        result.mainViewPrices_ = mainViewPrices_;
      } else {
        result.mainViewPrices_ = mainViewPricesBuilder_.build();
      }
      if (mainViewTradesBuilder_ == null) {
        if (((bitField0_ & 0x00000010) == 0x00000010)) {
          mainViewTrades_ = java.util.Collections.unmodifiableList(mainViewTrades_);
          bitField0_ = (bitField0_ & ~0x00000010);
        }
        result.mainViewTrades_ = mainViewTrades_;
      } else {
        result.mainViewTrades_ = mainViewTradesBuilder_.build();
      }
      result.bitField0_ = to_bitField0_;
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto) {
        return mergeFrom((com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto other) {
      if (other == com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto.getDefaultInstance()) return this;
      if (!other.getReportId().isEmpty()) {
        reportId_ = other.reportId_;
        onChanged();
      }
      if (other.reportType_ != 0) {
        setReportTypeValue(other.getReportTypeValue());
      }
      if (rangeViewPricesBuilder_ == null) {
        if (!other.rangeViewPrices_.isEmpty()) {
          if (rangeViewPrices_.isEmpty()) {
            rangeViewPrices_ = other.rangeViewPrices_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureRangeViewPricesIsMutable();
            rangeViewPrices_.addAll(other.rangeViewPrices_);
          }
          onChanged();
        }
      } else {
        if (!other.rangeViewPrices_.isEmpty()) {
          if (rangeViewPricesBuilder_.isEmpty()) {
            rangeViewPricesBuilder_.dispose();
            rangeViewPricesBuilder_ = null;
            rangeViewPrices_ = other.rangeViewPrices_;
            bitField0_ = (bitField0_ & ~0x00000004);
            rangeViewPricesBuilder_ = 
              com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                 getRangeViewPricesFieldBuilder() : null;
          } else {
            rangeViewPricesBuilder_.addAllMessages(other.rangeViewPrices_);
          }
        }
      }
      if (mainViewPricesBuilder_ == null) {
        if (!other.mainViewPrices_.isEmpty()) {
          if (mainViewPrices_.isEmpty()) {
            mainViewPrices_ = other.mainViewPrices_;
            bitField0_ = (bitField0_ & ~0x00000008);
          } else {
            ensureMainViewPricesIsMutable();
            mainViewPrices_.addAll(other.mainViewPrices_);
          }
          onChanged();
        }
      } else {
        if (!other.mainViewPrices_.isEmpty()) {
          if (mainViewPricesBuilder_.isEmpty()) {
            mainViewPricesBuilder_.dispose();
            mainViewPricesBuilder_ = null;
            mainViewPrices_ = other.mainViewPrices_;
            bitField0_ = (bitField0_ & ~0x00000008);
            mainViewPricesBuilder_ = 
              com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                 getMainViewPricesFieldBuilder() : null;
          } else {
            mainViewPricesBuilder_.addAllMessages(other.mainViewPrices_);
          }
        }
      }
      if (mainViewTradesBuilder_ == null) {
        if (!other.mainViewTrades_.isEmpty()) {
          if (mainViewTrades_.isEmpty()) {
            mainViewTrades_ = other.mainViewTrades_;
            bitField0_ = (bitField0_ & ~0x00000010);
          } else {
            ensureMainViewTradesIsMutable();
            mainViewTrades_.addAll(other.mainViewTrades_);
          }
          onChanged();
        }
      } else {
        if (!other.mainViewTrades_.isEmpty()) {
          if (mainViewTradesBuilder_.isEmpty()) {
            mainViewTradesBuilder_.dispose();
            mainViewTradesBuilder_ = null;
            mainViewTrades_ = other.mainViewTrades_;
            bitField0_ = (bitField0_ & ~0x00000010);
            mainViewTradesBuilder_ = 
              com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                 getMainViewTradesFieldBuilder() : null;
          } else {
            mainViewTradesBuilder_.addAllMessages(other.mainViewTrades_);
          }
        }
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.lang.Object reportId_ = "";
    /**
     * <code>optional string report_id = 1;</code>
     */
    public java.lang.String getReportId() {
      java.lang.Object ref = reportId_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        reportId_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getReportIdBytes() {
      java.lang.Object ref = reportId_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        reportId_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public Builder setReportId(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      reportId_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public Builder clearReportId() {
      
      reportId_ = getDefaultInstance().getReportId();
      onChanged();
      return this;
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public Builder setReportIdBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      reportId_ = value;
      onChanged();
      return this;
    }

    private int reportType_ = 0;
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public int getReportTypeValue() {
      return reportType_;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public Builder setReportTypeValue(int value) {
      reportType_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.ReportTypeDto getReportType() {
      com.accelfin.server.demo.analytics.dtos.ReportTypeDto result = com.accelfin.server.demo.analytics.dtos.ReportTypeDto.forNumber(reportType_);
      return result == null ? com.accelfin.server.demo.analytics.dtos.ReportTypeDto.UNRECOGNIZED : result;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public Builder setReportType(com.accelfin.server.demo.analytics.dtos.ReportTypeDto value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      reportType_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public Builder clearReportType() {
      
      reportType_ = 0;
      onChanged();
      return this;
    }

    private java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> rangeViewPrices_ =
      java.util.Collections.emptyList();
    private void ensureRangeViewPricesIsMutable() {
      if (!((bitField0_ & 0x00000004) == 0x00000004)) {
        rangeViewPrices_ = new java.util.ArrayList<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto>(rangeViewPrices_);
        bitField0_ |= 0x00000004;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> rangeViewPricesBuilder_;

    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> getRangeViewPricesList() {
      if (rangeViewPricesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(rangeViewPrices_);
      } else {
        return rangeViewPricesBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public int getRangeViewPricesCount() {
      if (rangeViewPricesBuilder_ == null) {
        return rangeViewPrices_.size();
      } else {
        return rangeViewPricesBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto getRangeViewPrices(int index) {
      if (rangeViewPricesBuilder_ == null) {
        return rangeViewPrices_.get(index);
      } else {
        return rangeViewPricesBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder setRangeViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto value) {
      if (rangeViewPricesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRangeViewPricesIsMutable();
        rangeViewPrices_.set(index, value);
        onChanged();
      } else {
        rangeViewPricesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder setRangeViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder builderForValue) {
      if (rangeViewPricesBuilder_ == null) {
        ensureRangeViewPricesIsMutable();
        rangeViewPrices_.set(index, builderForValue.build());
        onChanged();
      } else {
        rangeViewPricesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder addRangeViewPrices(com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto value) {
      if (rangeViewPricesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRangeViewPricesIsMutable();
        rangeViewPrices_.add(value);
        onChanged();
      } else {
        rangeViewPricesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder addRangeViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto value) {
      if (rangeViewPricesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRangeViewPricesIsMutable();
        rangeViewPrices_.add(index, value);
        onChanged();
      } else {
        rangeViewPricesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder addRangeViewPrices(
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder builderForValue) {
      if (rangeViewPricesBuilder_ == null) {
        ensureRangeViewPricesIsMutable();
        rangeViewPrices_.add(builderForValue.build());
        onChanged();
      } else {
        rangeViewPricesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder addRangeViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder builderForValue) {
      if (rangeViewPricesBuilder_ == null) {
        ensureRangeViewPricesIsMutable();
        rangeViewPrices_.add(index, builderForValue.build());
        onChanged();
      } else {
        rangeViewPricesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder addAllRangeViewPrices(
        java.lang.Iterable<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> values) {
      if (rangeViewPricesBuilder_ == null) {
        ensureRangeViewPricesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, rangeViewPrices_);
        onChanged();
      } else {
        rangeViewPricesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder clearRangeViewPrices() {
      if (rangeViewPricesBuilder_ == null) {
        rangeViewPrices_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
      } else {
        rangeViewPricesBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public Builder removeRangeViewPrices(int index) {
      if (rangeViewPricesBuilder_ == null) {
        ensureRangeViewPricesIsMutable();
        rangeViewPrices_.remove(index);
        onChanged();
      } else {
        rangeViewPricesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder getRangeViewPricesBuilder(
        int index) {
      return getRangeViewPricesFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder getRangeViewPricesOrBuilder(
        int index) {
      if (rangeViewPricesBuilder_ == null) {
        return rangeViewPrices_.get(index);  } else {
        return rangeViewPricesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public java.util.List<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> 
         getRangeViewPricesOrBuilderList() {
      if (rangeViewPricesBuilder_ != null) {
        return rangeViewPricesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(rangeViewPrices_);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder addRangeViewPricesBuilder() {
      return getRangeViewPricesFieldBuilder().addBuilder(
          com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder addRangeViewPricesBuilder(
        int index) {
      return getRangeViewPricesFieldBuilder().addBuilder(
          index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto range_view_prices = 3;</code>
     */
    public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder> 
         getRangeViewPricesBuilderList() {
      return getRangeViewPricesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> 
        getRangeViewPricesFieldBuilder() {
      if (rangeViewPricesBuilder_ == null) {
        rangeViewPricesBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
            com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder>(
                rangeViewPrices_,
                ((bitField0_ & 0x00000004) == 0x00000004),
                getParentForChildren(),
                isClean());
        rangeViewPrices_ = null;
      }
      return rangeViewPricesBuilder_;
    }

    private java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> mainViewPrices_ =
      java.util.Collections.emptyList();
    private void ensureMainViewPricesIsMutable() {
      if (!((bitField0_ & 0x00000008) == 0x00000008)) {
        mainViewPrices_ = new java.util.ArrayList<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto>(mainViewPrices_);
        bitField0_ |= 0x00000008;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> mainViewPricesBuilder_;

    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> getMainViewPricesList() {
      if (mainViewPricesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(mainViewPrices_);
      } else {
        return mainViewPricesBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public int getMainViewPricesCount() {
      if (mainViewPricesBuilder_ == null) {
        return mainViewPrices_.size();
      } else {
        return mainViewPricesBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto getMainViewPrices(int index) {
      if (mainViewPricesBuilder_ == null) {
        return mainViewPrices_.get(index);
      } else {
        return mainViewPricesBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder setMainViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto value) {
      if (mainViewPricesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureMainViewPricesIsMutable();
        mainViewPrices_.set(index, value);
        onChanged();
      } else {
        mainViewPricesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder setMainViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder builderForValue) {
      if (mainViewPricesBuilder_ == null) {
        ensureMainViewPricesIsMutable();
        mainViewPrices_.set(index, builderForValue.build());
        onChanged();
      } else {
        mainViewPricesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder addMainViewPrices(com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto value) {
      if (mainViewPricesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureMainViewPricesIsMutable();
        mainViewPrices_.add(value);
        onChanged();
      } else {
        mainViewPricesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder addMainViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto value) {
      if (mainViewPricesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureMainViewPricesIsMutable();
        mainViewPrices_.add(index, value);
        onChanged();
      } else {
        mainViewPricesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder addMainViewPrices(
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder builderForValue) {
      if (mainViewPricesBuilder_ == null) {
        ensureMainViewPricesIsMutable();
        mainViewPrices_.add(builderForValue.build());
        onChanged();
      } else {
        mainViewPricesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder addMainViewPrices(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder builderForValue) {
      if (mainViewPricesBuilder_ == null) {
        ensureMainViewPricesIsMutable();
        mainViewPrices_.add(index, builderForValue.build());
        onChanged();
      } else {
        mainViewPricesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder addAllMainViewPrices(
        java.lang.Iterable<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto> values) {
      if (mainViewPricesBuilder_ == null) {
        ensureMainViewPricesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, mainViewPrices_);
        onChanged();
      } else {
        mainViewPricesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder clearMainViewPrices() {
      if (mainViewPricesBuilder_ == null) {
        mainViewPrices_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
      } else {
        mainViewPricesBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public Builder removeMainViewPrices(int index) {
      if (mainViewPricesBuilder_ == null) {
        ensureMainViewPricesIsMutable();
        mainViewPrices_.remove(index);
        onChanged();
      } else {
        mainViewPricesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder getMainViewPricesBuilder(
        int index) {
      return getMainViewPricesFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder getMainViewPricesOrBuilder(
        int index) {
      if (mainViewPricesBuilder_ == null) {
        return mainViewPrices_.get(index);  } else {
        return mainViewPricesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public java.util.List<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> 
         getMainViewPricesOrBuilderList() {
      if (mainViewPricesBuilder_ != null) {
        return mainViewPricesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(mainViewPrices_);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder addMainViewPricesBuilder() {
      return getMainViewPricesFieldBuilder().addBuilder(
          com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder addMainViewPricesBuilder(
        int index) {
      return getMainViewPricesFieldBuilder().addBuilder(
          index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto main_view_prices = 4;</code>
     */
    public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder> 
         getMainViewPricesBuilderList() {
      return getMainViewPricesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder> 
        getMainViewPricesFieldBuilder() {
      if (mainViewPricesBuilder_ == null) {
        mainViewPricesBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
            com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder>(
                mainViewPrices_,
                ((bitField0_ & 0x00000008) == 0x00000008),
                getParentForChildren(),
                isClean());
        mainViewPrices_ = null;
      }
      return mainViewPricesBuilder_;
    }

    private java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto> mainViewTrades_ =
      java.util.Collections.emptyList();
    private void ensureMainViewTradesIsMutable() {
      if (!((bitField0_ & 0x00000010) == 0x00000010)) {
        mainViewTrades_ = new java.util.ArrayList<com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto>(mainViewTrades_);
        bitField0_ |= 0x00000010;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDtoOrBuilder> mainViewTradesBuilder_;

    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto> getMainViewTradesList() {
      if (mainViewTradesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(mainViewTrades_);
      } else {
        return mainViewTradesBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public int getMainViewTradesCount() {
      if (mainViewTradesBuilder_ == null) {
        return mainViewTrades_.size();
      } else {
        return mainViewTradesBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto getMainViewTrades(int index) {
      if (mainViewTradesBuilder_ == null) {
        return mainViewTrades_.get(index);
      } else {
        return mainViewTradesBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder setMainViewTrades(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto value) {
      if (mainViewTradesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureMainViewTradesIsMutable();
        mainViewTrades_.set(index, value);
        onChanged();
      } else {
        mainViewTradesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder setMainViewTrades(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder builderForValue) {
      if (mainViewTradesBuilder_ == null) {
        ensureMainViewTradesIsMutable();
        mainViewTrades_.set(index, builderForValue.build());
        onChanged();
      } else {
        mainViewTradesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder addMainViewTrades(com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto value) {
      if (mainViewTradesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureMainViewTradesIsMutable();
        mainViewTrades_.add(value);
        onChanged();
      } else {
        mainViewTradesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder addMainViewTrades(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto value) {
      if (mainViewTradesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureMainViewTradesIsMutable();
        mainViewTrades_.add(index, value);
        onChanged();
      } else {
        mainViewTradesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder addMainViewTrades(
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder builderForValue) {
      if (mainViewTradesBuilder_ == null) {
        ensureMainViewTradesIsMutable();
        mainViewTrades_.add(builderForValue.build());
        onChanged();
      } else {
        mainViewTradesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder addMainViewTrades(
        int index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder builderForValue) {
      if (mainViewTradesBuilder_ == null) {
        ensureMainViewTradesIsMutable();
        mainViewTrades_.add(index, builderForValue.build());
        onChanged();
      } else {
        mainViewTradesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder addAllMainViewTrades(
        java.lang.Iterable<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto> values) {
      if (mainViewTradesBuilder_ == null) {
        ensureMainViewTradesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, mainViewTrades_);
        onChanged();
      } else {
        mainViewTradesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder clearMainViewTrades() {
      if (mainViewTradesBuilder_ == null) {
        mainViewTrades_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000010);
        onChanged();
      } else {
        mainViewTradesBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public Builder removeMainViewTrades(int index) {
      if (mainViewTradesBuilder_ == null) {
        ensureMainViewTradesIsMutable();
        mainViewTrades_.remove(index);
        onChanged();
      } else {
        mainViewTradesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder getMainViewTradesBuilder(
        int index) {
      return getMainViewTradesFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDtoOrBuilder getMainViewTradesOrBuilder(
        int index) {
      if (mainViewTradesBuilder_ == null) {
        return mainViewTrades_.get(index);  } else {
        return mainViewTradesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public java.util.List<? extends com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDtoOrBuilder> 
         getMainViewTradesOrBuilderList() {
      if (mainViewTradesBuilder_ != null) {
        return mainViewTradesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(mainViewTrades_);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder addMainViewTradesBuilder() {
      return getMainViewTradesFieldBuilder().addBuilder(
          com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder addMainViewTradesBuilder(
        int index) {
      return getMainViewTradesFieldBuilder().addBuilder(
          index, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto main_view_trades = 5;</code>
     */
    public java.util.List<com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder> 
         getMainViewTradesBuilderList() {
      return getMainViewTradesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDtoOrBuilder> 
        getMainViewTradesFieldBuilder() {
      if (mainViewTradesBuilder_ == null) {
        mainViewTradesBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
            com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDto.Builder, com.accelfin.server.demo.analytics.dtos.FxAlertsReportTradeDtoOrBuilder>(
                mainViewTrades_,
                ((bitField0_ & 0x00000010) == 0x00000010),
                getParentForChildren(),
                isClean());
        mainViewTrades_ = null;
      }
      return mainViewTradesBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto)
  private static final com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto();
  }

  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<FxAlertsReportResponseDto>
      PARSER = new com.google.protobuf.AbstractParser<FxAlertsReportResponseDto>() {
    public FxAlertsReportResponseDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new FxAlertsReportResponseDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<FxAlertsReportResponseDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<FxAlertsReportResponseDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportResponseDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

